Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPPDTW/CVRPPDTWEvaluator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPPDTW/CVRPPDTWEvaluator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPPDTW/CVRPPDTWEvaluator.cs	(revision 6851)
@@ -85,5 +85,5 @@
 
         //drive there
-        double currentDistace = vrptw.GetDistance(start, end);
+        double currentDistace = vrptw.GetDistance(start, end, solution);
         time += currentDistace;
         distance += currentDistace;
@@ -166,5 +166,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, TourInsertionInfo tourInsertionInfo, int index, int customer, 
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer, 
       out bool feasible) {
       CVRPPDTWInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPPDTWInsertionInfo;
@@ -187,8 +187,8 @@
       double pickupPenalty = pdp.PickupViolationPenalty.Value;
 
-      double distance = instance.GetDistance(insertionInfo.Start, insertionInfo.End);
+      double distance = instance.GetDistance(insertionInfo.Start, insertionInfo.End, solution);
       double newDistance =
-        instance.GetDistance(insertionInfo.Start, customer) +
-        instance.GetDistance(customer, insertionInfo.End);
+        instance.GetDistance(insertionInfo.Start, customer, solution) +
+        instance.GetDistance(customer, insertionInfo.End, solution);
       costs += instance.DistanceFactor.Value * (newDistance - distance);
 
@@ -215,5 +215,5 @@
       if (index > 0)
         time = (tourInsertionInfo.GetStopInsertionInfo(index - 1) as CVRPTWInsertionInfo).LeaveTime;
-      time += instance.GetDistance(insertionInfo.Start, customer);
+      time += instance.GetDistance(insertionInfo.Start, customer, solution);
       if (time > dueTime[customer]) {
         tardiness += time - dueTime[customer];
@@ -222,5 +222,5 @@
         time += readyTime[customer] - time;
       time += serviceTimes[customer];
-      time += instance.GetDistance(customer, insertionInfo.End);
+      time += instance.GetDistance(customer, insertionInfo.End, solution);
 
       double additionalTime = time - (tourInsertionInfo.GetStopInsertionInfo(index) as CVRPTWInsertionInfo).ArrivalTime;
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWEvaluator.cs	(revision 6851)
@@ -92,5 +92,5 @@
 
         //drive there
-        double currentDistace = vrptw.GetDistance(start, end);
+        double currentDistace = vrptw.GetDistance(start, end, solution);
         time += currentDistace;
         distance += currentDistace;
@@ -150,5 +150,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       CVRPTWInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPTWInsertionInfo;
@@ -166,8 +166,8 @@
       double tardinessPenalty = vrptw.TardinessPenalty.Value;
 
-      double distance = instance.GetDistance(insertionInfo.Start, insertionInfo.End);
+      double distance = instance.GetDistance(insertionInfo.Start, insertionInfo.End, solution);
       double newDistance =
-        instance.GetDistance(insertionInfo.Start, customer) +
-        instance.GetDistance(customer, insertionInfo.End);
+        instance.GetDistance(insertionInfo.Start, customer, solution) +
+        instance.GetDistance(customer, insertionInfo.End, solution);
       costs += instance.DistanceFactor.Value * (newDistance - distance);
 
@@ -186,5 +186,5 @@
       if (index > 0)
         time = (tourInsertionInfo.GetStopInsertionInfo(index - 1) as CVRPTWInsertionInfo).LeaveTime;
-      time += instance.GetDistance(insertionInfo.Start, customer);
+      time += instance.GetDistance(insertionInfo.Start, customer, solution);
       if (time > dueTime[customer]) {
         tardiness += time - dueTime[customer];
@@ -193,5 +193,5 @@
         time += readyTime[customer] - time;
       time += serviceTimes[customer];
-      time += instance.GetDistance(customer, insertionInfo.End);
+      time += instance.GetDistance(customer, insertionInfo.End, solution);
 
       double additionalTime = time - (tourInsertionInfo.GetStopInsertionInfo(index) as CVRPTWInsertionInfo).ArrivalTime;
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPEvaluator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPEvaluator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPEvaluator.cs	(revision 6851)
@@ -57,5 +57,5 @@
 
         //drive there
-        double currentDistace = instance.GetDistance(start, end);
+        double currentDistace = instance.GetDistance(start, end, solution);
         distance += currentDistace;
 
@@ -75,5 +75,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       StopInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index);
@@ -82,8 +82,8 @@
       feasible = true;
 
-      double distance = instance.GetDistance(insertionInfo.Start, insertionInfo.End);
+      double distance = instance.GetDistance(insertionInfo.Start, insertionInfo.End, solution);
       double newDistance =
-        instance.GetDistance(insertionInfo.Start, customer) +
-        instance.GetDistance(customer, insertionInfo.End);
+        instance.GetDistance(insertionInfo.Start, customer, solution) +
+        instance.GetDistance(customer, insertionInfo.End, solution);
 
       costs += instance.DistanceFactor.Value * (newDistance - distance);
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPEvaluator.cs	(revision 6851)
@@ -103,10 +103,11 @@
     }
 
-    protected abstract double GetTourInsertionCosts(IVRPProblemInstance instance, TourInsertionInfo tourInsertionInfo, int index, int customer, out bool feasible);
+    protected abstract double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer, out bool feasible);
 
-    public double GetInsertionCosts(IVRPProblemInstance instance, VRPEvaluation eval, int customer, int tour, int index, out bool feasible) {
+    public double GetInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, VRPEvaluation eval, int customer, int tour, int index, out bool feasible) {
       bool tourFeasible;
       double costs = GetTourInsertionCosts(
         instance,
+        solution,
         eval.InsertionInfo.GetTourInsertionInfo(tour), index,
         customer, out tourFeasible);
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs	(revision 6851)
@@ -188,9 +188,23 @@
     }
 
+    public virtual double[] GetCoordinates(int city) {
+      double[] coordinates = new double[Coordinates.Columns];
+
+      for (int i = 0; i < Coordinates.Columns; i++) {
+        coordinates[i] = Coordinates[city, i];
+      }
+
+      return coordinates;
+    }
+
+    public virtual double GetDemand(int city) {
+      return Demand[city];
+    }
+
     //cache for performance improvement
     private DoubleMatrix distanceMatrix = null;
     private IVRPEvaluator evaluator = null;
 
-    public double GetDistance(int start, int end) {
+    public virtual double GetDistance(int start, int end, IVRPEncoding solution) {
       double distance = 0.0;
       if (distanceMatrix == null && UseDistanceMatrix.Value) {
@@ -206,4 +220,13 @@
     }
 
+    public virtual double GetInsertionDistance(int start, int customer, int end, IVRPEncoding solution) {
+      double distance = GetDistance(start, end, solution);
+      double newDistance =
+        GetDistance(start, customer, solution) +
+        GetDistance(customer, end, solution);
+
+      return newDistance - distance;
+    }
+
     public bool Feasible(IVRPEncoding solution) {
       return evaluator.Feasible(
@@ -230,6 +253,6 @@
     }
 
-    public double GetInsertionCosts(VRPEvaluation eval, int customer, int tour, int index, out bool feasible) {
-      return evaluator.GetInsertionCosts(this, eval, customer, tour, index, out feasible);
+    public double GetInsertionCosts(VRPEvaluation eval, IVRPEncoding solution, int customer, int tour, int index, out bool feasible) {
+      return evaluator.GetInsertionCosts(this, solution, eval, customer, tour, index, out feasible);
     }
 
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/MultiDepot/IMultiDepotOperator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/MultiDepot/IMultiDepotOperator.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/MultiDepot/IMultiDepotOperator.cs	(revision 6851)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface IMultiDepotOperator: IVRPOperator {
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/MultiDepot/IMultiDepotProblemInstance.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/MultiDepot/IMultiDepotProblemInstance.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Variants/MultiDepot/IMultiDepotProblemInstance.cs	(revision 6851)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.VehicleRouting.Variants {
+  public interface IMultiDepotProblemInstance: IVRPProblemInstance {
+    IntValue Depots { get; }
+    IntArray VehicleDepotAssignment { get; }
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/VehicleRoutingProblem.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/VehicleRoutingProblem.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/VehicleRoutingProblem.cs	(revision 6851)
@@ -243,8 +243,35 @@
     #endregion
 
+    public void ImportFromCordeau(string cordeauFileName) {
+      CordeauParser parser = new CordeauParser(cordeauFileName);
+      parser.Parse();
+
+      MDCVRPProblemInstance problem = new MDCVRPProblemInstance();
+
+      problem.Coordinates = new DoubleMatrix(parser.Coordinates);
+      problem.Vehicles.Value = parser.Vehicles;
+      problem.Capacity = new DoubleArray(parser.Capacity);
+      problem.Demand = new DoubleArray(parser.Demands);
+      problem.Depots.Value = parser.Depots;
+      problem.VehicleDepotAssignment = new IntArray(parser.Vehicles);
+      int depot = 0;
+      int i = 0;
+      while(i < parser.Vehicles) {
+        problem.VehicleDepotAssignment[i] = depot;
+
+        i++;
+        if (i % (parser.Vehicles / parser.Depots) == 0)
+          depot++;
+      }
+
+      this.ProblemInstance = problem;
+
+      OnReset();
+    }
+
     public void ImportFromLiLim(string liLimFileName) {
       LiLimParser parser = new LiLimParser(liLimFileName);
       parser.Parse();
-      
+
       CVRPPDTWProblemInstance problem = new CVRPPDTWProblemInstance();
 
@@ -372,5 +399,5 @@
         } else {
           problem.Demand[i] = rand.Next(10, 50);
-          problem.DueTime[i] = rand.Next((int)Math.Ceiling(problem.GetDistance(0, i)), 1200);
+          problem.DueTime[i] = rand.Next((int)Math.Ceiling(problem.GetDistance(0, i, null)), 1200);
           problem.ReadyTime[i] = problem.DueTime[i] - rand.Next(0, 100);
           problem.ServiceTime[i] = 90;
